eval 'exec perl -x $0 ${1+"$@"}' # -*-perl-*-
  if 0;
#!perl -w
#
# SIDEN agent
# Copyright (C) 2000 Lawrence Teo
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

# =======================================================================
# Package modules
# =======================================================================
use Net::Inet;
use Net::TCP::Server;
use Net::RawIP;       # to obtain the source IP and device

# =======================================================================
# Forward declarations
# =======================================================================
sub perform_scan;
sub logmsg;
sub gen_current_time;

#$required_version = "0.1.0";

my $DEBUG = 0;

my %cfg;  # used to keep the configuration details

my $default_cfg_filename = "agentrc";
my $cfg_filename = $default_cfg_filename;
my $cfg_key;
my $cfg_value;

# Read from the configuration file first
open(CFG, "$cfg_filename") or die("Cannot open $cfg_filename");
while (<CFG>) {
    chomp;
    next if (/^\s*#/);    # ignore comments
    next if (/^\s*$/);    # ignore blank lines

    ($cfg_key, $cfg_value) = /^\s*([^=]+)=([^=]+)\s*$/;
    $cfg{$cfg_key} = $cfg_value;
}
close(CFG);

if ($DEBUG >= 1) {
    while (($cfg_key, $cfg_value) = each %cfg) {
        print "config: $cfg_key = $cfg_value\n";
    }

}

# Check if nmap is around
#my @default_nmap_locations = (
#    "/usr/bin/nmap",
#    "/usr/local/bin/nmap",
#    "/usr/sbin/nmap",
#    "/usr/local/sbin/nmap",
#    "./nmap"
#);
#
#if (!(-f $cfg{nmapbin})) {
#    for $nmap_location (@default_nmap_locations) {
#    }
#
#    if (-f "/usr/local/bin/nmap") {
#        $cfg{nmapbin} = "/usr/local/bin/nmap";
#    } else {
#        print "Can't find the nmap binary!\n";
#    }
#}

# Start the server

$lh = 'Net::TCP::Server'->new($cfg{port}) or die;
print "Agent " . $cfg{name} . " started on port " . $cfg{port} . "...\n";

while ($sh = $lh->accept) {
    defined($pid = fork) or die "fork: $!\n";
    if ($pid) {
        $sh->stopio;
        next;
    }
    $lh->stopio;
    # do per-connection stuff here
    #$sh->send("testing");
    $quit = 0;
    #while (($buffer = readline($sh)) & ($quit == 0)) {

    $current_time = gen_current_time;
    logmsg("----------" . $current_time . " MASTER " . $sh->format_remote_addr);

    #print($sh->format_remote_addr . scalar localtime);

    while ($quit == 0) {
        $cmd = readline($sh);

        next if (!defined($cmd));

        chomp($cmd);
        logmsg("     Command: $cmd");
        #print "Received: $cmd\n" if ($DEBUG >= 1);

        if (($cmd eq "") | ($cmd =~ /^quit$/)) {
            $quit = 1;
            next;
        }

        if ($cmd =~ /^[ST]:[^:]+:\d+:[^:]+:[^:]+$/) {
            print "Looks okay\n" if ($DEBUG >= 1);
            ($scan_type, $version, $delay, $target, $ports) =
                split(/:/, $cmd);

            my $open_ports = perform_scan($scan_type, $delay, "", $target, $ports);
            #print "Open ports: $open_ports\n";
            logmsg("     Results: $open_ports");
            $sh->print($open_ports . "\n");
        }
    }
    exit;
}

# perform_scan(type, delay,  src_ip, dst_ip, ports)
sub perform_scan {
    my $scan_type = shift;
    my $delay = shift;
    my $src_ip = shift;
    my $dst_ip = shift;
    #my @ports = @_;
    my $ports = shift;
    my $open_port;
    my $open_ports;

#    my %port_states = {
#        open => "+"
#        filtered => "f"
#    };

    my %port_states = qw(
        open +
        filtered f
    );

    #print "$port_states{open}\n";

    if (($scan_type eq "S") && ($> != 0)) {
        print "You have to be root to use half-open SYN scanning.\n";
        return "$target:error, Agent is not installed as root";
    }

    $nmap_cmd = $cfg{nmapbin} . " -s$scan_type -r -p$ports --scan_delay $delay ";
    if ($src_ip ne "") {
        $nmap_cmd .= "-S$src_ip -e$device ";
    }
    $nmap_cmd .= "$target |";

    $open_ports = "";
    #open(NMAP, "$nmap -s$scan_type -S$src_ip -r -p$ports $target |");
    #print "Nmap command: $nmap_cmd\n" if ($DEBUG >= 1);
    logmsg("     Nmap command: $nmap_cmd");
    open(NMAP, $nmap_cmd);
    while (<NMAP>) {
        chomp;
        undef($open_port);
        ($open_port, $state) = $_ =~ m#^(\d+)/tcp\s+(\S+)\s+\S+\s*$#;
        if (defined($open_port)) {
            $open_ports .= ($open_port . $port_states{$state} . ",") if defined($open_port);
        }
    }
    close(NMAP);

    #print "In perform_scan(), open_ports is $open_ports\n" if ($DEBUG >= 1);
    return "$target:$open_ports";
}

sub logmsg {
    my @msg = @_;

    open(LOGFILE, ">>$cfg{logfile}") or
        die("Cannot open $cfg{logfile}");
    print LOGFILE "@msg\n";
    print "@msg\n" if ($DEBUG >= 1);
    close LOGFILE;
}

sub gen_current_time {
    my $current_time = scalar localtime;
    my $formatted_time;

    ($day, $mon, $date, $time, $year) = $current_time =~
          /(\S+)\s+(\S+)\s+(\d+)\s+(\d+:\d+:\d+)\s+(\d+)/;

    $formatted_time = sprintf("[%s %s/%s/%s:%s]", $day, $date, $mon,
                              $year, $time);

    return $formatted_time;
}
